/* Modified by Pasquale Frega in 06-Aug-2023 */
import java.io.File; // Import the File class
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException; // Import the IOException class to handle errors
import java.util.Scanner;
public class FileSplitterProcess {
 File mFile;
 Scanner fileReader;
 public boolean loadFile(String fileName) {
  try {
   mFile = new File(fileName);
   fileReader = new Scanner(mFile);
   while (fileReader.hasNextLine())
    break;
   fileReader.close();
   return true;
  } catch (FileNotFoundException e) {
   e.printStackTrace();
   return false;
  }
 }
 public boolean processFiles(String targetDir, String sourceFile, int splitAt, boolean headerAtStart, boolean putHeaderinAllFiles) {
  String baseTargetFileName, data, firstLine = "", targetFileName, fileExt = sourceFile.substring(sourceFile.indexOf('.'));
  int counter, fileCounter;
  FileWriter fileWriter = null;
  if(targetDir.equals("")) {
   baseTargetFileName = sourceFile.substring(0, sourceFile.indexOf('.'));
  } else {
   baseTargetFileName = targetDir + File.separator + (new File(sourceFile).getName());
   baseTargetFileName = baseTargetFileName.substring(0, baseTargetFileName.indexOf('.'));
  }
  try {
   fileReader = new Scanner(mFile);
   counter = 0;
   fileCounter = 1;
   while (fileReader.hasNextLine()) {
    data = fileReader.nextLine();
    if (counter == 0)
     if (headerAtStart == true) {
      firstLine = data.toString(); // get the first line to put it in next files
      data = fileReader.nextLine();
     }
    // split the file
    if (counter % splitAt == 0) {
     if (fileWriter != null) {
      fileWriter.close();
      fileCounter++;
     }
     targetFileName = baseTargetFileName + '-' + fileCounter + fileExt;
     fileWriter = new FileWriter(targetFileName);
     if (putHeaderinAllFiles == true) {
      fileWriter.write(firstLine);
      fileWriter.write(System.lineSeparator());
     }
    }
    fileWriter.write(data.toString());
    fileWriter.write(System.lineSeparator());
    counter++;
   }
   fileReader.close();
   if (fileWriter != null)
    fileWriter.close();
   return true;
  } catch (FileNotFoundException e) {
   e.printStackTrace();
  } catch (IOException e) {
   e.printStackTrace();
  }
  return false;
 }
}