/*
 * JMultiSend 20240101 - Mass emails sender (Bulk E-mail) and mailing list manager
 *
 * Copyright (C) 2024 Pasquale Frega
 * All rights reserved
 *
 * Released under [SEE LICENSE FILE]
 *
 * last edit: 11-Dec-2023
 */
/*
 * begin
 */
 import javax.mail.*;
 import javax.swing.*;
 import java.io.*;
 import java.awt.*;
 import javax.swing.filechooser.*;
 import java.util.Date;
 import ru.krlvm.swingdpi.SwingDPI;
 import javax.swing.text.*;
 import java.awt.event.*;
 import java.util.*;
 import javax.mail.internet.*;
 public class JMultiSend {
  private static String _userid, _password;
  private static class SMTPAuthenticator extends javax.mail.Authenticator {
   public PasswordAuthentication getPasswordAuthentication() {
    return new PasswordAuthentication(_userid, _password);
   }
  }
  static JFrame _fr = new JFrame("JMultiSend 20240101");
  private static String readTextFile(File _file) {
   String _out = "";
   try {
    BufferedReader _in = new BufferedReader(new FileReader(_file));
    String _line = "";
    while((_line = _in.readLine()) != null)
     _out += _line + '\n';
    _in.close();
   } catch(IOException _err_msg) {
    JOptionPane.showMessageDialog(_fr, _err_msg, "Error", JOptionPane.ERROR_MESSAGE);
   }
   return(_out);
  }
  static JTextArea _txa = new JTextArea("Program ready.\n", 27, 65);
  private static class Read extends TextAction {
   private Read() {
    super("Read...");
    putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control R"));
   }
   public void actionPerformed(ActionEvent _event) {
    JFileChooser _fc = new JFileChooser();
    _fc.setDialogTitle("Select Output File");
    _fc.setCurrentDirectory(new File("."));
    _fc.setFileFilter(new FileNameExtensionFilter("Output File", "out"));
    if(_fc.showOpenDialog(_fr) == JFileChooser.APPROVE_OPTION) {
     _fr.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
     String _append = readTextFile(_fc.getSelectedFile());
     if(!(_append.equals(""))) {
      _txa.append(_append);
      _txa.setCaretPosition(_txa.getDocument().getLength());
     }
     _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
   }
  }
  static JTextArea _fnd = new JTextArea(null, 25, 62);
  static JScrollPane _fsp = new JScrollPane(_fnd);
  private static class Search extends TextAction {
   private Search() {
    super("Search...");
    putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control S"));
   }
   public void actionPerformed(ActionEvent _event) {
    String _search, _content = _txa.getText();
    if((_search = JOptionPane.showInputDialog(_fr, "Search (RegExp):", "Search...", JOptionPane.QUESTION_MESSAGE)) != null)
     if(!(_search.equals(""))) {
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      String _found = "";
      int _arr_len, _total = 0;
      try {
       for(String _string: _content.split("\n"))
        if((_arr_len = (_string + '\0').split(_search).length) > 1) {
         _found += _string + '\n';
         _total += _arr_len - 1;
        }
       } catch(Exception _err_msg) {
        _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        JOptionPane.showMessageDialog(_fr, _err_msg, "Error", JOptionPane.ERROR_MESSAGE);
        return;
       }
      _fnd.setText("Search result for \"" + _search + "\":\n" + _found + "Total found: " + _total);
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      JOptionPane.showConfirmDialog(_fr, _fsp, "Found", JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE);
     }
   }
  }
  private static class InsertDate extends TextAction {
   private InsertDate() {
    super("Insert Date");
    putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control D"));
   }
   public void actionPerformed(ActionEvent _event) {
    _txa.append(new Date(System.currentTimeMillis()) + "\n");
    _txa.setCaretPosition(_txa.getDocument().getLength());
   }
  }
  private static void saveOutputFile(File _file, String _out) {
   try {
    if(_file.exists())
     if((JOptionPane.showConfirmDialog(_fr, "This file will be overwritten, do you want to continue?", "Warning", JOptionPane.YES_NO_OPTION)) == 1)
      return;
    BufferedWriter _in = new BufferedWriter(new FileWriter(_file));
    _in.write(_out);
    _in.close();
    JOptionPane.showMessageDialog(_fr, "Operation successful.");
   } catch(IOException _err_msg) {
    JOptionPane.showMessageDialog(_fr, _err_msg, "Error", JOptionPane.ERROR_MESSAGE);
   }
  }
  private static class Save extends TextAction {
   private Save() {
    super("Save As...");
    putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control V"));
   }
   public void actionPerformed(ActionEvent _event) {
    JFileChooser _fc = new JFileChooser();
    _fc.setDialogTitle("Save Output As...");
    _fc.setCurrentDirectory(new File("."));
    _fc.setSelectedFile(new File("jmultisend.out"));
    if(_fc.showOpenDialog(_fr) == JFileChooser.APPROVE_OPTION)
     saveOutputFile(_fc.getSelectedFile(), _txa.getText());
   }
  }
  private static class Clear extends TextAction {
   private Clear() {
    super("Clear");
    putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control C"));
   }
   public void actionPerformed(ActionEvent _event) {
    _txa.setText("");
   }
  }
  private static String _list = "", _type, _subject, _message = "", _data = "";
  public static void main(String _args[]) {
   File _accepted = new File("accepted");
   SwingDPI.applyScalingAutomatically();
   if(!_accepted.exists())
    if((JOptionPane.showConfirmDialog(null, "Do you accept the terms and conditions of the license file?", "Terms And Conditions", JOptionPane.YES_NO_OPTION)) == 1)
     return;
    else
     try {
      _accepted.createNewFile();
     } catch (IOException _err_msg) {
      JOptionPane.showMessageDialog(null, _err_msg, "Error", JOptionPane.ERROR_MESSAGE);
     }
   _fr.setIconImage(new ImageIcon(ClassLoader.getSystemClassLoader().getResource("icon-16x16.png")).getImage());
   _fr.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   _fr.setResizable(false);
   _fr.setLayout(new BoxLayout(_fr.getContentPane(), BoxLayout.Y_AXIS));
   JButton _uls = new JButton("Update List");
   _uls.setToolTipText("Update list file");
   JButton _lls = new JButton("Load List");
   _lls.setToolTipText("Load file as list");
   JButton _lms = new JButton("Load Message");
   _lms.setToolTipText("Load file as message");
   JButton _ldt = new JButton("Load Data");
   _ldt.setToolTipText("Load file as sending data");
   JButton _sms = new JButton("Send Message");
   _sms.setToolTipText("Send message to recipients");
   UIManager.put("FileChooser.readOnly", Boolean.TRUE);
   JButton _abt = new JButton("About");
   _abt.setToolTipText("About this program");
   JButton _ext = new JButton("Exit");
   _ext.setToolTipText("Close and exit");
   InputMap _im = (InputMap)UIManager.get("Button.focusInputMap");
   _im.put(KeyStroke.getKeyStroke("ENTER"), "pressed");
   _im.put(KeyStroke.getKeyStroke("released ENTER"), "released");
   _abt.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent _event) {
     JOptionPane.showMessageDialog(_fr, "<html><center><img src='" + getClass().getResource("icon-64x64.png").toString() + "'><br><b>JMultiSend<br><i>fast send<br>mass emails</i><br>@@@<br></b><small>Copyright (c) 2024, Pasquale<br>Frega - All rights reserved.<br><a href=''>pasqualefrega.antiblog.com</a><br>Released under<br>[SEE LICENSE FILE]</small></center></html>", "About", JOptionPane.INFORMATION_MESSAGE);
    }
   });
   _ext.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent _event) {
     System.exit(0);
    }
   });
   SwingDPI.scaleFont(_txa);
   _txa.setEditable(false);
   _txa.setLineWrap(true);
   JPopupMenu _mn = new JPopupMenu();
   Action _read = new Read();
   _mn.add(_read);
   SwingDPI.scaleFont(_fnd);
   _fnd.setEditable(false);
   _fnd.setLineWrap(true);
   Action _search = new Search();
   _mn.add(_search);
   Action _now = new InsertDate();
   _mn.add(_now);
   Action _save = new Save();
   _mn.add(_save);
   Action _clear = new Clear();
   _mn.add(_clear);
   _txa.setComponentPopupMenu(_mn);
   JScrollPane _tsp = new JScrollPane(_txa);
   _uls.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent _event) {
     JFileChooser _fc = new JFileChooser();
     _fc.setDialogTitle("Select List File");
     _fc.setCurrentDirectory(new File("."));
     _fc.setFileFilter(new FileNameExtensionFilter("Text File", "txt"));
     if(_fc.showOpenDialog(_fr) == JFileChooser.APPROVE_OPTION) {
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      File _lfile = _fc.getSelectedFile();
      String _lst = readTextFile(_lfile);
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      _fc.setDialogTitle("Select Update File");
      _fc.setSelectedFile(new File(""));
      if(_fc.showOpenDialog(_fr) == JFileChooser.APPROVE_OPTION) {
       _fr.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
       File _ufile = _fc.getSelectedFile();
       String _udata[] = readTextFile(_ufile).toLowerCase().split("\n");
       _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
       _txa.append("Update \"" + _lfile.getName() + "\" in progress please wait...\n");
       _txa.setCaretPosition(_txa.getDocument().getLength());
       if((_password = JOptionPane.showInputDialog(_fr, "Password:", "Type Password", JOptionPane.QUESTION_MESSAGE)) != null) {
        try {
         String _host = _udata[0].split("=")[1].trim(), _uid = _udata[1].split("=")[1].trim(), _add = _udata[2].split("=")[1].trim(), _remove = _udata[3].split("=")[1].trim(), _sb, _fr, _out = "", _nw_lst = "";
         Boolean _pres;
         Properties _props = System.getProperties();
         Session _sess = Session.getDefaultInstance(_props);
         Store _store = _sess.getStore("pop3");
         try {
          _store.connect(_host, _uid, _password);
          Folder _inbox = _store.getFolder("Inbox");
          _inbox.open(Folder.READ_ONLY);
          Message _messages[] = _inbox.getMessages();
          if (_messages.length > 0)
           for (int _num = 0; _num < _messages.length; _num++) {
            _sb = _messages[_num].getSubject().toLowerCase().trim();
            _fr = _messages[_num].getFrom()[0].toString();
            if(_sb.equals(_add)) {
             _pres = false;
             for(String _addr: _lst.split("\n"))
              if(_fr.toLowerCase().equals(_addr.toLowerCase())) {
               _pres = true;
               _out += "WARNING, already present " + _fr + '\n';
               break;
              }
             if(!_pres) {
              _lst += _fr + '\n';
              _out += "Successfully added " + _fr +'\n';
             }
            }
            if(_sb.equals(_remove)) {
             _pres = true;
             for(String _addr: _lst.split("\n"))
              if(_fr.toLowerCase().equals(_addr.toLowerCase())) {
               _pres = false;
               _out += "Successfully removed " + _fr +'\n';
              } else {
               _nw_lst += _addr + '\n';
              }
             if(_pres)
              _out += "WARNING, unable to remove " + _fr +'\n';
             _lst = _nw_lst;
             _nw_lst = "";
            }
           }
          _inbox.close(true);
          _store.close();
          BufferedWriter _in = new BufferedWriter(new FileWriter(_lfile));
          _in.write(_lst);
          _in.close();
         } catch (Exception _err_msg) {
          _out += _err_msg.toString() + '\n';
         }
         _txa.append(_out + "Operation finished.\n");
         _txa.setCaretPosition(_txa.getDocument().getLength());
        } catch(Exception _err_msg) {
         _txa.append(_err_msg.toString() + "\nOperation aborted.\n");
         _txa.setCaretPosition(_txa.getDocument().getLength());
        }
       } else {
        _txa.append("Operation aborted.\n");
        _txa.setCaretPosition(_txa.getDocument().getLength());
       }
      }
     }
    }
   });
   _lls.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent _event) {
     JFileChooser _fc = new JFileChooser();
     _fc.setDialogTitle("Select List File");
     _fc.setCurrentDirectory(new File("."));
     _fc.setFileFilter(new FileNameExtensionFilter("Text File", "txt"));
     if(_fc.showOpenDialog(_fr) == JFileChooser.APPROVE_OPTION) {
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      File _lfile = _fc.getSelectedFile();
      _list = readTextFile(_lfile);
      if(!(_list.equals(""))) {
       _txa.append("\"" + _lfile.getName() + "\" loaded as list file.\n");
       _txa.setCaretPosition(_txa.getDocument().getLength());
      }
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
     }
    }
   });
   _lms.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent _event) {
     JFileChooser _fc = new JFileChooser();
     _fc.setDialogTitle("Select Message File");
     _fc.setCurrentDirectory(new File("."));
     _fc.setFileFilter(new FileNameExtensionFilter("Text or HTML File", "txt", "html"));
     if(_fc.showOpenDialog(_fr) == JFileChooser.APPROVE_OPTION) {
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      File _mfile = _fc.getSelectedFile();
      String _mfile_name = _mfile.getName(), _parts[] = _mfile_name.split("[.]");
      _type = _parts[_parts.length - 1].toLowerCase();
      _subject = _mfile_name.replaceFirst("[.][^.]+$", "");
      _message = readTextFile(_mfile);
      if(!(_message.equals(""))) {
       _txa.append("\"" + _mfile_name + "\" loaded as message file and its name as subject.\n");
       _txa.setCaretPosition(_txa.getDocument().getLength());
      }
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
     }
    }
   });
   _ldt.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent _event) {
     JFileChooser _fc = new JFileChooser();
     _fc.setDialogTitle("Select Data File");
     _fc.setCurrentDirectory(new File("."));
     _fc.setFileFilter(new FileNameExtensionFilter("Text File", "txt"));
     if(_fc.showOpenDialog(_fr) == JFileChooser.APPROVE_OPTION) {
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      File _dfile = _fc.getSelectedFile();
      _data = readTextFile(_dfile);
      if(!(_data.equals(""))) {
       _txa.append("\"" + _dfile.getName() + "\" loaded as sending data file.\n");
       _txa.setCaretPosition(_txa.getDocument().getLength());
      }
      _fr.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
     }
    }
   });
   _sms.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent _event) {
     if(_list.equals("") || _message.equals("") || _data.equals("")) {
      _txa.append("No list or message or data file loaded.\n");
      _txa.setCaretPosition(_txa.getDocument().getLength());
     } else {
      _txa.append("Sending in progress please wait...\n");
      _txa.setCaretPosition(_txa.getDocument().getLength());
      if((_password = JOptionPane.showInputDialog(_fr, "Password (if required):", "Type Password", JOptionPane.QUESTION_MESSAGE)) != null) {
       _fr.setTitle("JMultiSend 20240101 (Zzz)");
       SpinnerNumberModel _sm = new SpinnerNumberModel(0, 0, 86400, 1);
       JSpinner _s = new JSpinner(_sm);
       JOptionPane.showMessageDialog(_fr, _s, "Sleep (secs)", JOptionPane.QUESTION_MESSAGE);
       try {
        Thread.sleep((Integer)_s.getValue() * 1000);
       } catch(InterruptedException _err_msg) {
        _txa.append(_err_msg.toString() + '\n');
        _txa.setCaretPosition(_txa.getDocument().getLength());
       }
       _fr.setTitle("JMultiSend 20240101");
       Properties _props = System.getProperties();
       _props.setProperty("mail.smtp.localhost", "127.0.0.1");
       String _sdata[] = _data.split("\n");
       try {
        String _host = _sdata[0].split("=")[1].trim();
        _props.setProperty("mail.smtp.host", _host);
        Session _sess;
        if(!(_password.equals(""))) {
         _props.setProperty("mail.smtp.auth", "true");
         _userid = _sdata[3].split("=")[1].trim();
         Authenticator _auth = new SMTPAuthenticator();
         _sess = Session.getInstance(_props, _auth);
        } else {
         _props.setProperty("mail.smtp.auth", "false");
         _sess = Session.getInstance(_props);
        }
        String _new_message, _from = _sdata[1].split("=")[1].trim(), _out = "";
        byte _1st = 1;
        int _count = 1, _tot = _list.length() - _list.replace("\n", "").length(), _delay = Integer.parseInt(_sdata[2].split("=")[1].trim());
        for(String _to: _list.split("\n")) {
         _new_message = _message.replace("${user}", _to.replaceAll("<.*>", "").trim());
         try {
          MimeMessage _mess = new MimeMessage(_sess);
          _mess.setFrom(new InternetAddress(_from));
          _mess.addRecipient(Message.RecipientType.TO, new InternetAddress(_to));
          _mess.setSubject(_subject);
          if(_type.equals("html"))
           _mess.setContent(_new_message, "text/html");
          else
           _mess.setText(_new_message);
          Transport.send(_mess);
          _out += "Message successfully sent to " + _to + '\n';
         } catch (MessagingException _err_msg) {
            _out += _err_msg.toString() + '\n';
            if(_1st == 1)
             break;
         }
         _1st = 0;
         _fr.setTitle("JMultiSend 20240101 (" + Integer.toString(_count++) + " of " + Integer.toString(_tot) +")");
         try {
          Thread.sleep(_delay * 1000);
         } catch(InterruptedException _err_msg) {
          _txa.append(_err_msg.toString() + '\n');
          _txa.setCaretPosition(_txa.getDocument().getLength());
          break;
         }
        }
        _fr.setTitle("JMultiSend 20240101");
        _txa.append(_out + "Operation finished.\n");
        _txa.setCaretPosition(_txa.getDocument().getLength());
       } catch(Exception _err_msg) {
        _txa.append(_err_msg.toString() + "\nOperation aborted.\n");
        _txa.setCaretPosition(_txa.getDocument().getLength());
       }
      } else {
       _txa.append("Operation aborted.\n");
       _txa.setCaretPosition(_txa.getDocument().getLength());
      }
     }
    }
   });
   JPanel _bts = new JPanel();
   _bts.add(_uls);
   _bts.add(_lls);
   _bts.add(_lms);
   _bts.add(_ldt);
   _bts.add(_sms);
   _bts.add(_abt);
   _bts.add(_ext);
   _fr.add(_bts);
   _fr.add(_tsp);
   _fr.pack();
   _fr.setLocationRelativeTo(null);
   _fr.setVisible(true);
  }
 }
/*
 * end
 */
